/*
  Very Quick & Dirty Icom CIV write operating freq command (By Warezzman) 
  Based on miniterm.c
 */

/*  Miniterm AUTHOR: Sven Goldt (goldt@math.tu-berlin.de)
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
*/
/*
 This is like all programs in the Linux Programmer's Guide meant
 as a simple practical demonstration.
 It can be used as a base for a real terminal program.
*/

//#include <termios.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>


#define _POSIX_SOURCE 1 /* POSIX compliant source */

#define FALSE 0
#define TRUE 1

#define BAUDRATE B9600
#define MODEMDEVICE "/dev/ttyS0"  /* where your CIV interface is: ttyS0 for COM1, ttyS1 for COM2 */

#define CIV_DEST 00  /* 00 CIV Broadcast address, will work with all equiment but
                                   you can change this with your receiver address */

#define DEBUG_CIV 0    /* print CIV frame to send */

volatile int STOP=FALSE; 
char datos[] = "\xfe\xfe\x00\xe0\x05\x00\x00\x00\x30\x02\xfd";  /* CIV frame */
char temporal[11]  = "0230000000";
char t2[11] = "0230000000";
char cadena[200] = "";

void setfreq(double freq)
{
int fd,i;
long int f;

struct termios oldtio,newtio;

/* some dirty manipulation to create CIV frame (freq) payload */

f = freq * 1000000;
printf("TRACKING]");
sprintf(temporal,"0%ld",f);

  for (i=1;i<10;i++) {
     t2[10-i] = temporal[i-1];
  } 


#if 0

    printf("\n temporal: %s", temporal);
    printf("\n temporal 2: %s ",t2);

#endif


  sprintf(cadena," 0x%c%c ",t2[1],t2[0]);
  datos[5] = strtol(cadena, NULL, 16);


  sprintf(cadena," 0x%c%c ",t2[3],t2[2]);
  datos[6] = strtol(cadena, NULL, 16);


  sprintf(cadena," 0x%c%c ",t2[5],t2[4]);
  datos[7] = strtol(cadena, NULL, 16);


  sprintf(cadena," 0x%c%c ",t2[7],t2[6]);
  datos[8] = strtol(cadena, NULL, 16);

  sprintf(cadena," 0x%c%c ",t2[9],t2[8]);
  datos[9] = strtol(cadena, NULL, 16);



 
/* 
  Open modem device for reading and writing and not as controlling tty
  because we don't want to get killed if linenoise sends CTRL-C.
*/
 fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY);
 if (fd <0) {perror(MODEMDEVICE); exit(-1); }
 
 tcgetattr(fd,&oldtio); /* save current modem settings */
 
/* 
  Set bps rate and hardware flow control and 8n1 (8bit,no parity,1 stopbit).
  Also don't hangup automatically and ignore modem status.
  Finally enable receiving characters.
*/
 newtio.c_cflag = BAUDRATE | CS8 | CLOCAL; // | CREAD;
 
/*
 Ignore bytes with parity errors and make terminal raw and dumb.
*/
 newtio.c_iflag = IGNPAR;
 
/*
 Raw output.
*/
 newtio.c_oflag = 0;
 
/*
 Don't echo characters because if you connect to a host it or your
 modem will echo characters for you. Don't generate signals.
*/
 newtio.c_lflag = 0;
 
/* blocking read until 1 char arrives */
 newtio.c_cc[VMIN]=1;
 newtio.c_cc[VTIME]=0;
 
/* now clean the modem line and activate the settings for modem */
 tcflush(fd, TCIFLUSH);
 tcsetattr(fd,TCSANOW,&newtio);

/*
  Strange, but if you uncomment this command miniterm will not work
  even if you stop canonical mode for stdout. This is a linux bug.
*/
// tcsetattr(1,TCSANOW,&newtio); /* stdout settings like modem settings */


#if DEBUG_CIV

  printf("\n CIV Frame:");
  for (i=0;i<11;i++) {
     printf(" %x ",datos[i]);
   } 
  printf("\n");

#endif

   write(fd,&datos,11);


   close(fd);
}
